%options for optimization and numerical derivatives
options=optimset('MaxFunEvals',10^5,'MaxIter',10^5,'TolFun',10^-8);
%options=optimset('MaxFunEvals',10^3,'MaxIter',10^3,'TolFun',10^-8);
stepsize=10^-6;


%setting the objective function
if identificationapproach==1
    if symmetric==0
        LLH = @(Psi)ReplicationAnalyticLogLikelihood(Psi(1), Psi(2), [Psi(3:end) 1],cutoffs,symmetric, Z, sigmaZ2);
    else
        if spec_test==1;
            %LLH=@(Psi)ReplicationAnalyticLogLikelihood(0, Psi(1), [Psi(2:end) 1],cutoffs,symmetric, Z, sigmaZ2);
            
            LLH=@(Psi) ReplicationpzthetaLogLikelihood(0, Psi(1), [Psi(2:2+length(cutoffs)-1) 1],...
                [zeros(1,length(Psi(2:2+length(cutoffs)-1))) 0], cutoffs,symmetric, Z, sigmaZ2,...
                vcutoff, Zdraws, Thetadraws,zdrawsd,thetadrawsd);
            
            LLH_test=@(Psi) ReplicationpzthetaLogLikelihood(0, Psi(1), [Psi(2:2+length(cutoffs)-1) 1],...
                [Psi(2+length(cutoffs):end) 0], cutoffs,symmetric, Z, sigmaZ2,...
                vcutoff, Zdraws, Thetadraws,zdrawsd,thetadrawsd);
            
        else
            LLH = @(Psi)ReplicationAnalyticLogLikelihood(0, Psi(1), [Psi(2:end) 1],cutoffs,symmetric, Z, sigmaZ2);
            %Alternative specification to allow a non-zero mean
            %LLH = @(Psi)ReplicationAnalyticLogLikelihood(Psi(1), Psi(2), [Psi(3:end) 1],cutoffs,symmetric, Z, sigmaZ2);
        end
    end
    nn=n;
elseif  identificationapproach==2
    if symmetric==0
        if symmetric_p==1
            LLH = @(Psi) VariationVarianceLogLikelihood(Psi(1), Psi(2), [1 Psi(3:end) fliplr(Psi(3:end)) 1],cutoffs,symmetric, X(includeinestimation), sigma(includeinestimation),0);
            nn=sum(includeinestimation);
        else
            LLH = @(Psi) VariationVarianceLogLikelihood(Psi(1), Psi(2), [Psi(3:end) 1],cutoffs,symmetric, X(includeinestimation), sigma(includeinestimation),0);
            nn=sum(includeinestimation);
        end
    else
        LLH = @(Psi) VariationVarianceLogLikelihood(0, Psi(1), [Psi(2:end) 1],cutoffs,symmetric, X(includeinestimation), sigma(includeinestimation),0);
        nn=sum(includeinestimation);     
    end
end

%find maximum likelihood estimator using just LLH
if spec_test==1
    [Psihat, LLHmax] = fminunc(LLH,Psihat0,options);
    [Psihat, LLHmax] = fminsearch(LLH,Psihat,options);
    
    Psihat_test=[Psihat zeros(1,length(cutoffs))];
    score_mat=zeros(n , length(Psihat_test));
    for n1=1:length(Psihat_test)
        theta_plus=Psihat_test;
        theta_plus(n1)=theta_plus(n1)+stepsize;
        [LLH_plus, logL_plus]=LLH_test(theta_plus);
        theta_minus=Psihat_test;
        theta_minus(n1)=theta_minus(n1)-stepsize;
        [LLH_minus, logL_minus]=LLH_test(theta_minus);
        score_mat(:,n1)=(logL_plus-logL_minus)/(2*stepsize);
    end
    
    %score_stat=mean(score_mat)*(score_mat'*score_mat)^-1*mean(score_mat)';
    score_stat=n*mean(score_mat)*cov(score_mat)^-1*mean(score_mat)';
    score_pval=1-chi2cdf(score_stat,length(cutoffs));
    
else
    [Psihat, LLHmax] = fminunc(LLH,Psihat0,options);
    [Psihat, LLHmax] = fminsearch(LLH,Psihat,options);
    
    Var_robust=RobustVariance(stepsize, nn, Psihat, LLH,cluster_ID);
    se_robust=diag(Var_robust).^.5;
    
    SelectionTable(Psihat,se_robust,name,(identificationapproach==1),symmetric)
end

%Try random starting values to check convergence
% Psihat_orig=Psihat;
% LLHmax_orig=LLHmax;
% numstarts=20;
% for j=1:numstarts
%     Psihat0=randn(1,length(Psihat0))*5;
%     Psihat0(2)=abs(Psihat0(2));
%     [Psihat, LLHmax] = fminunc(LLH,Psihat0,options);
%     [Psihat, LLHmax] = fminsearch(LLH,Psihat,options);
%     Psihat_temp(j,:)=Psihat;
%     LLHmax_temp(j,:)=LLHmax;
% end
%find the robust variance matrix

% sanity check for replication studies
if identificationapproach==1 && spec_test==0
    if symmetric==1 
    	LLH = @(Psi) VariationVarianceLogLikelihood(0, Psi(1), [Psi(2:end) 1],cutoffs,symmetric, X, sigma,1);
    else
    	%Alternative specification to allow a non-zero mean
    	LLH = @(Psi) VariationVarianceLogLikelihood(Psi(1), Psi(2), [Psi(3:end) 1],cutoffs,symmetric, X, sigma,1);
    end
    [PsihatSanity1, LLHmax] = fminunc(LLH,Psihat0,options);
    [PsihatSanity1, LLHmax] = fminsearch(LLH,PsihatSanity1,options);
    Var_robustSanity1=RobustVariance(stepsize, nn, PsihatSanity1, LLH,cluster_ID);
    se_robustSanity1=diag(Var_robustSanity1).^.5;
    
    SelectionTable(PsihatSanity1,se_robustSanity1,[name 'Sanitycheck'],0,symmetric)
end



